import { AbstractCrudObject } from './../abstract-crud-object';
import Cursor from './../cursor';
import LiveVideo from './live-video';
export default class Event extends AbstractCrudObject {
    static get Fields(): Record<string, any>;
    static get Category(): Record<string, any>;
    static get OnlineEventFormat(): Record<string, any>;
    static get Type(): Record<string, any>;
    static get EventStateFilter(): Record<string, any>;
    static get TimeFilter(): Record<string, any>;
    getComments(fields: string[], params?: Record<string, any>): Promise<Cursor>;
    getComments(fields: string[], params: Record<string, any> | undefined, fetchFirstPage: false): Cursor;
    getComments(fields: string[], params?: Record<string, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getFeed(fields: string[], params?: Record<string, any>): Promise<Cursor>;
    getFeed(fields: string[], params: Record<string, any> | undefined, fetchFirstPage: false): Cursor;
    getFeed(fields: string[], params?: Record<string, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getLiveVideos(fields: string[], params?: Record<string, any>): Promise<Cursor>;
    getLiveVideos(fields: string[], params: Record<string, any> | undefined, fetchFirstPage: false): Cursor;
    getLiveVideos(fields: string[], params?: Record<string, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    createLiveVideo(fields: string[], params?: Record<string, any>, pathOverride?: string | null): Promise<LiveVideo>;
    getPhotos(fields: string[], params?: Record<string, any>): Promise<Cursor>;
    getPhotos(fields: string[], params: Record<string, any> | undefined, fetchFirstPage: false): Cursor;
    getPhotos(fields: string[], params?: Record<string, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getPicture(fields: string[], params?: Record<string, any>): Promise<Cursor>;
    getPicture(fields: string[], params: Record<string, any> | undefined, fetchFirstPage: false): Cursor;
    getPicture(fields: string[], params?: Record<string, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getPosts(fields: string[], params?: Record<string, any>): Promise<Cursor>;
    getPosts(fields: string[], params: Record<string, any> | undefined, fetchFirstPage: false): Cursor;
    getPosts(fields: string[], params?: Record<string, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getRoles(fields: string[], params?: Record<string, any>): Promise<Cursor>;
    getRoles(fields: string[], params: Record<string, any> | undefined, fetchFirstPage: false): Cursor;
    getRoles(fields: string[], params?: Record<string, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getTicketTiers(fields: string[], params?: Record<string, any>): Promise<Cursor>;
    getTicketTiers(fields: string[], params: Record<string, any> | undefined, fetchFirstPage: false): Cursor;
    getTicketTiers(fields: string[], params?: Record<string, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    getVideos(fields: string[], params?: Record<string, any>): Promise<Cursor>;
    getVideos(fields: string[], params: Record<string, any> | undefined, fetchFirstPage: false): Cursor;
    getVideos(fields: string[], params?: Record<string, any>, fetchFirstPage?: boolean): Cursor | Promise<Cursor>;
    get(fields: string[], params?: Record<string, any>): Promise<Event>;
}
